#ifndef SC_SENSITIVE_H
#define SC_SENSITIVE_H

#include <sc_signal.h>
#include <sc_signal_ports.h>
#include <sc_fifo.h>
#include <sc_fifo_ports.h>
#include <sc_event.h>

namespace sc_core
{

class sc_sensitive;



class sc_sensitive
{
    public:

    void operator()(const sc_signal_base& sig)
    { sc_signal_sensitivity(sig); }

    void operator()(const sc_port_base& port)
    { sc_port_sensitivity(port); }

    private:

    void sc_signal_sensitivity(const sc_signal_base&);
    void sc_port_sensitivity(const sc_port_base&);

    void sc_event_sensitivity(const sc_event&);

    friend sc_sensitive& operator << (sc_sensitive& s, const sc_signal_base& sig)
    {
        s.sc_signal_sensitivity(sig);
        return s;
    }

    friend sc_sensitive& operator << (sc_sensitive& s, const sc_port_base& port)
    {
        s.sc_port_sensitivity(port);
        return s;
    }

    friend sc_sensitive& operator << (sc_sensitive& s, const sc_event& e)
    {
        s.sc_event_sensitivity(e);
        return s;
    }
};

extern sc_sensitive sensitive;
extern sc_sensitive sensitive_pos;
extern sc_sensitive sensitive_neg;


}

#endif

// Taf!
